/***************************************************************************
                          clouds.h  -  description
                             -------------------
    begin                : Sun Oct 1 2000
    copyright            : (c) 2000 by Matthew Mastracci
    email                : mmastrac@canada.com
 ***************************************************************************/

#ifndef CLOUDS_H
#define CLOUDS_H

#include "glplatform.h"
#include "texture.h"
#include <vector>

class CClouds {
public: 
	CClouds();
	~CClouds();

	void Tick( long lMSElapsed );
	void GLSetup();	
	void GLRender();
	void GLTeardown();
	
protected:
	void _CreateRandomTextures();
	void _FillRandomTexture( unsigned char bTexture[32][32] );

	typedef unsigned char SmallTexture[32][32];
	typedef unsigned char FinalTexture[256][256][2];

	// The 32x32 textures required for the detail level
	SmallTexture* _Textures;

	// The 32x32 textures, sized up to 256n x 256n (n = detail level)
	unsigned char* _LargeTextures;

	// Used to help resize the large textures
	unsigned char* _LargeTextureScratchpad;

	// The final 256x256 textures
	FinalTexture* _FinalTextures;

	// Lookup table for cloud densities
	unsigned char _CloudLookupTable[256];

	typedef std::vector< CTexture > Textures;
	Textures	_SkyTextures;
	int	_nSkyDisplayList;

	long _lOffset[4];

	// Bound variables
	long g_lCloudDetailLevel;
	long g_lCloudTextureSegments;
	float g_fCloudSharpness;
	long g_lCloudCover;


	long _lCloudTextures;
	long _lCloudTextureDimension;
	long _lCloudTextureSize;
	long _lCloudFinalTextures;
};

#endif
