/***************************************************************************
                          console.cpp  -  description
                             -------------------
    begin                : Sun Oct 8 2000
    copyright            : (c) 2000 by Matthew Mastracci
    email                : mmastrac@canada.com
 ***************************************************************************/

/***************************************************************************
                          clouds.h  -  description
                             -------------------
    begin                : Sun Oct 1 2000
    copyright            : (c) 2000 by Matthew Mastracci
    email                : mmastrac@canada.com
 ***************************************************************************/

#include <stdio.h>
#include <fstream>
#include <iostream>

#include "global.h"
#include "console.h"

using namespace std;

CConsole::CConsole()
{
	g_lConsoleSize = 40;
	_lWidth = 800;
	_lHeight = 600; // (fixme)

	ofs.open( "log.txt" );


	ofs << "============================ Start of log ============================ " << endl;
}

CConsole::~CConsole()
{
	ofs << "============================= End of log ============================= " << endl;
	ofs << endl;
	ofs.close();
}

void CConsole::AddMessage( const char* szMessage, ... )
{
	const long MAX_LENGTH = 512;
	char szBuff[ MAX_LENGTH ];

	va_list args;

	va_start( args, szMessage );

#ifdef _WIN32
	_vsnprintf( szBuff, MAX_LENGTH, szMessage, args );
#else
	vsnprintf( szBuff, MAX_LENGTH, szMessage, args );
#endif
	szBuff[ MAX_LENGTH - 1 ] = 0;

	va_end( args );

#ifdef _WIN32
	OutputDebugString( szBuff );
	OutputDebugString( "\n" );
#else
	cout << szBuff << endl;
#endif

	ofs << szBuff << endl;

	_LastMessages.push_back( szBuff );
	while ( (long)_LastMessages.size() > g_lConsoleSize )
	{
		_LastMessages.pop_front();
	}
}

void CConsole::GLSetup()
{
	_fConsole.Load( "font" );	
}

void CConsole::GLTeardown()
{
	_fConsole.Release();
}

void CConsole::GLRender()
{
	glMatrixMode( GL_PROJECTION );
	glPushMatrix();
	{
		glLoadIdentity();
		gluOrtho2D( 0, _lWidth, _lHeight, 0 );
		glMatrixMode( GL_MODELVIEW );
		glPushMatrix();
		{
			glLoadIdentity();

			long lSize = _LastMessages.size();

			for ( long i = lSize > 10 ? 0 : 10 - lSize; i < 10; i++ )
			{
				std::string& strMessage = *( _LastMessages.end() - ( 10 - i ) );

				_fConsole.Render( 10, i * 16, strMessage.c_str() );
			}
		}
		glPopMatrix();
		glMatrixMode( GL_PROJECTION );

	}
	glPopMatrix();
}