/***************************************************************************
                          font.cpp  -  description
                             -------------------
    begin                : Sun Oct 8 2000
    copyright            : (c) 2000 by Matthew Mastracci
    email                : mmastrac@canada.com
 ***************************************************************************/

#include "font.h"

CFont::CFont()
{
}

void CFont::Load( const char* szFont )
{
	_tFont.Load( szFont );
}

void CFont::Render( long lX, long lY, const char* szText )
{
	_tFont.Bind();
	glColor3f( 1, 1, 1 );
	glBegin( GL_QUADS );
	{
		for ( unsigned long i = 0; i < strlen( szText ); i++ )
		{
			char c = szText[ i ] - 32;
			float fInvCharSize = 1 / 16.0f;
			float fInvTextureSize = 1 / 255.0f;
			float fTexCoordX = float( ( c & 0x0f ) << 4 ) * fInvTextureSize;
			float fTexCoordY = float( c & 0xf0 ) * fInvTextureSize;

			glTexCoord2f( fTexCoordX, fTexCoordY );
			glVertex2i( lX, lY );
			glTexCoord2f( fTexCoordX, fTexCoordY + fInvCharSize );
			glVertex2i( lX, lY + 16 );
			glTexCoord2f( fTexCoordX + fInvCharSize, fTexCoordY + fInvCharSize );
			glVertex2i( lX + 16, lY + 16 );
			glTexCoord2f( fTexCoordX + fInvCharSize, fTexCoordY );
			glVertex2i( lX + 16, lY );

			lX += 12;
		}
	}
	glEnd();
}

void CFont::Release()
{
	_tFont.Release();
}