/***************************************************************************
                          mixer.h  -  description
                             -------------------
    begin                : Thu Oct 12 2000
    copyright            : (c) 2000 by Matthew Mastracci
    email                : mmastrac@canada.com
 ***************************************************************************/


#ifndef MIXER_H
#define MIXER_H

#include <vector>
using namespace std;

#include "soundplatform.h"

class CSound;

class CMixer
{
public:
	void Setup( long lChannels );
	void Teardown();
	void Load( const char* szSound, CSound* pSound );
	void Play( CSound& Sound );
	void PlayLooped( CSound& Sound );
	void Stop( CSound& Sound );

	long GetFreeChannel() const;
#ifdef _WIN32
	HQMIXER GetMixerHandle() const { return _hQMixer; };
#endif

protected:
#ifdef _WIN32
	HQMIXER _hQMixer;
#endif
};

#endif